﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace FieldChooserForHierarchy
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ObservableCollection<Data> data = new ObservableCollection<Data>();

            for (int i = 0; i < 10; i++)
            {
                Data d = new Data
                {
                    ID = i,
                    Name = "Parent" +i,
                    ParentId = null,
                    Children = new ObservableCollection<Data>()
                };

                for (int j = 0; j < 10; j++)
                {
                    d.Children.Add(new Data
                    {
                        ID = j,
                        Name = "Child" + j,
                        ParentId = i
                    });
                }
                
                data.Add(d);
            }

            DataContext = data;
        }

        private void XamDataGrid_AssigningFieldLayoutToItem(object sender, Infragistics.Windows.DataPresenter.Events.AssigningFieldLayoutToItemEventArgs e)
        {
            if ((e.Item as Data).ParentId == null)
                e.FieldLayout = (sender as XamDataGrid).FieldLayouts["Parent"];
            else
                e.FieldLayout = (sender as XamDataGrid).FieldLayouts["Child"];
        }
    }

    public class Data
    {
        public int ID { get; set; }
        public string Name { get; set; }
        public int? ParentId { get; set; }

        public ObservableCollection<Data> Children { get; set; }
    }
}
